lang = new Array(lang,
{	
	//////////////////////////////////
    //INDICATION ADDIT
    /////////////////////////////////
	
	"iec.class"				:		"IEC 61000-2-4 Class",
	"iec.class1"			:		"Class 1 (Protected supply)",
	"iec.class2"			:		"Class 2 (General PCC/IPC)",
	"iec.class3"			:		"Class 3 (Industrial IPC)",
	
    //////////////////////////////////
    //BLACKFIN FACELIFT 2017 ADDITIONS
    /////////////////////////////////
    
    "info.device"			:		"Device information",
	"rcm.title"         	:       "RCM (Live Values)",
    
    //new menu items
    "menu.transients"       :       "Transients",
    "menu.graphs"           :       "Graphs",
    "menu.powerquality"     :       "Power Quality",
    "menu.iec61000ind"      :       "IEC61000-2-4 Indication",
    "menu.en50160ind"       :       "EN50160 Indication",
    "menu.iec61000watchdog" :       "IEC61000-2-4 Watchdog",
       "menu.rcm":"RCM",
    
    //month abbrevations (for usage graph)
    "month1"                :       "Jan",
    "month2"                :       "Feb",
    "month3"                :       "Mar",
    "month4"                :       "Apr",
    "month5"                :       "May",
    "month6"                :       "Jun",
    "month7"                :       "Jul",
    "month8"                :       "Aug",
    "month9"                :       "Sept",
    "month10"               :       "Oct",
    "month11"               :       "Nov",
    "month12"               :       "Dec",
    
    //welcome page
    "home.usagegraphtitle"  :       "Usage graph",
    "home.pqstatus"         :       "Power quality status",
    "home.iecindication"    :       "IEC61000-2-4 Indication",
    "home.enindiation"      :       "EN 50160 Indication",
    "home.iecnorm"          :       "Last IEC61000-2-4 report status",
    "home.ennorm"           :       "Last EN50160 report status",
    "home.evt24hours"       :       "Events in the last 24 hours",
    "home.trn24hours"       :       "Transients in the last 24 hours",
    "home.loadstatus"       :       "Live values",
    "home.phase"            :       "Phase",
    "home.voltage"          :       "Voltage (LN)",
    "home.current"          :       "Current",
    "home.power"            :       "Active Power",
    "home.cos"              :       "Cos-phi",
    "home.graphperiod"      :       "Graph period ",
    "home.yearly"           :       "Yearly",
    "home.monthly"          :       "Monthly",
    "home.daily"            :       "Daily",
    "home.dateselection"    :       "Date selection",
    "home.next"             :       "Next",
    "home.previous"         :       "Previous",
    "home.nodata"           :       "No usage data available for the selected period",
    
    
    "home.iecgreen"         :       "Inside IEC61000-2-4 limits (< 80%)",
    "home.iecorange"        :       "Inside IEC61000-2-4 limits (> 80%)",
    "home.iecred"           :       "Outside IEC61000-2-4 limits",
    "home.iecna"            :       "Report not available",
    
    "home.engreen"          :       "Inside EN50160 limits (< 80%)",
    "home.enorange"         :      	"Inside EN50160 limits (> 80%)",
    "home.enred"            :     	"Outside EN50160 limits",
    "home.enna"             :       "Report not available",
    
    //event page
    "event.list"            :       "Eventlist (Last 32 events)",
    "event.nodata"          :       "Graph not available on the homepage.<br>Too many values for this Webbrowser.<br>Please check GridVis for details.",
	"event.endmessage"		:		"No further events can be displayed on the homepage.<br>Please use GridVis to view further data",
    "event.wait"            :       "Please wait for the event to load before selecting another event",
    
    //apps page
    "apps.descriptiontitle" :       "Software based expansions for the measurement devices",
    "apps.description1"     :       "Modern measurement devices can deliver a lot - and so their operation has become complex. One option for the placement of the controls is on the device itself - using buttons or touch displays. This sets limits on the desire for more compact devices and on the installation situation. An alternative is a notebook, but this is not always at hand when working. In addition when operating without a work station is quickly becomes very tiring holding the notebook with one hand whilst typing with the other.",
    "apps.description2"     :       "A third option would be to use compact control devices that can be used with one hand and which can communicate with the device by cable or by radio thus enhancing the operating level. Until a few years ago these would be costly, device-specific custom solutions. Nowadays, almost everyone has the hardware in their pocket: A smartphone or tablet.",
    "apps.description3"     :       "There are numerous apps, which run on both classical PC's and mobile end devices, to choose from for Janitza devices, These allow the operator to read out, edit and display data, receive alarms or simplify the configuration. Communication is implemented directly with a device or via the GridVis software, depending on the application. In doing so, the apps can also work as sub-programs that simplify certain working steps.",

    //imprint page (still in german)
    "imprint.pagetitle"     :       "About",
    "imprint.title1"        :       "Address",
    "imprint.title2"        :       "Represented by",
    "imprint.title3"        :       "Contact",
    "imprint.title4"        :       "Register entry",
    "imprint.title5"        :       "Tax-ID",
    "imprint.title6"        :       "Tax number",
    
    "imprint.text1"         :       "Janitza electronics GmbH<br>Vor dem Polst\u00fcck 6<br>35633 Lahnau, Germany",
    "imprint.text2"         :       "Mr. Markus Janitza and Mr. Rudolf M\u00fcller<br>Vor dem Polst\u00fcck 6<br>35633 Lahnau, Germany",
    "imprint.text3"         :       "Phone: +49 6441 9642-0<br>Fax: +49 6441 9642-30<br>E-Mail: info@janitza.de<br>Web: http://www.janitza.com",
    "imprint.text4"         :       "Registration in the commercial register:<br>Register: Wetzlar<br>Registration number: HRB 928",
    "imprint.text5"         :       "Sales tax identification number according to<br>\u00a727 a Sales Tax Law DE112616565",
    "imprint.text6"         :       "02 02 365 0179",
    
    
     "voltage.eff"           :       "Voltage Effective",
    "voltage.under"         :       "Voltage Under difference(rel.) - (61000-4-30)",
    "voltage.over"          :       "Voltage Over difference(rel.) - (61000-4-30)",
    "voltage.crest"         :       "Voltage Crestfactor",
    "voltage.negpeak"       :       "Negative Peak Voltage",
    "voltage.pospeak"       :       "Positive Peak Voltage",
    "voltage.peakpeak"      :       "Peak to Peak Voltage",
    "voltage.3phaseval"     :       "Three-phase Values",
    "voltage.posphaseseq"   :       "Positive Phase Sequence",
    "voltage.negphaseseq"   :       "Negative Phase Sequence",
    "voltage.zerophaseseq"  :       "Zero Phase Sequence",
    "voltage.unbalance"     :       "Voltage unbalance",
    "voltage.dir"           :       "Rotating field direction",
    "voltage.dirnone"       :       "None",
    "voltage.dirleft"       :       "Left",
    "voltage.dirright"      :       "Right",
    "voltage.freq"          :       "Frequency",
    
    "current.eff"           :       "Current Effective",
    "current.under"         :       "Current Under difference(rel.) - (61000-4-30)",
    "current.over"          :       "Current Over difference(rel.) - (61000-4-30)",
    "current.crest"         :       "Current Crestfactor",
    "current.negpeak"       :       "Negative Peak Current",
    "current.pospeak"       :       "Positive Peak Current",
    "current.peakpeak"      :       "Peak to Peak Current",
    "current.kfactor"       :       "K-Factor",
    "current.3phaseval"     :       "Three-phase Values",
    "current.posphaseseq"   :       "Positive Phase Sequence",
    "current.negphaseseq"   :       "Negative Phase Sequence",
    "current.zerophaseseq"  :       "Zero Phase Sequence",
    "current.unbalance"     :       "Unbalance Current",
    
    "power.active"          :       "Active Power",
    "power.reactive"        :       "Reactive Power (fundamental comp.)",
    "power.apparent"        :       "Apparent Power",
    "power.distortion"      :       "Distortion Power",
    "power.cosphi"          :       "Cos-Phi",
    "power.pf"              :       "Power Factor",
    "power.angle"           :       "Phase Angle",
    
    "harmonics.thdu"        :       "Total Harmonic Distortion - Voltage (THD-U)",
    "harmonics.thdi"        :       "Total Harmonic Distortion - Current (THD-I)",
    "harmonics.tdd"         :       "Total Demand Distortion (TDD)",
    "harmonics.individual"  :       "Individual Harmonics Overview",
    "harmonics.ULL"         :       "Harmonic Voltage (LL)",
    "harmonics.UL"          :       "Harmonic Voltage (LN)",
    "harmonics.IL"          :       "Harmonic Current",
    "harmonics.PL"          :       "Harmonic Active Power",
    "harmonics.QL"          :       "Harmonic Reactive Power",
    "harmonics.ULLZ"        :       "Interharmonic Voltage (LL)",
    "harmonics.ULZ"         :       "Interharmonic Voltage (LN)",
    "harmonics.ILZ"         :       "Interharmonic Current",
    
    "ext.actualvalue"       :       "Actual value",
    "ext.countervalue"      :       "Counter value",
    "ext.devicetemp"        :       "Device temperature",
    "ext.externaltemp"      :       "External temperature",
    
    "info.rxtxerr"          :       "Packets RX/TX/ERROR",
    
    //////////////////////////////////
    //END OF BLACKFIN FACELIFT 2017 ADDITIONS
    /////////////////////////////////
    
    
"app.request":"For more information about this app or to order it, go to <a target='_blank' href='http://www.janitza.com'>www.janitza.com</a>",
"1-2":"1-2",
"2-3":"2-3",
"3-1":"3-1",
"DIFF1":"Diff1",
"DIFF2":"Diff2",
"EN50160.ACTUAL":"Actual <br> value",
"EN50160.ASYM":"Unbalance",
"EN50160.AVG":"Average value <br> (last ",
"EN50160.FREQ":"Frequency",
"EN50160.GRAPHNORM":"Limit EN 50160",
"EN50160.L1":"Phase Voltage L1",
"EN50160.L1L2":"Line Voltage L1-L3",
"EN50160.L2":"Phase Voltage L2",
"EN50160.L2L3":"Line Voltage L2-L3",
"EN50160.L3":"Phase Voltage L3",
"EN50160.L3L1":"Line Voltage L3-L1",
"EN50160.LFLICKL1":"Long term flicker L1",
"EN50160.LFLICKL2":"Long term flicker L2",
"EN50160.LFLICKL3":"Long term flicker L3",
"EN50160.MAX":"Maximum <br> value",
"EN50160.MAXNORM":"Upper limit <br> avg. EN 50160",
"EN50160.MIN":"Minimum <br> value",
"_G_THD_ILN[0]":"THD-I L1",
"_G_THD_ILN[1]":"THD-I L2",
"_G_THD_ILN[2]":"THD-I L3",
"EN50160.MINNORM":"Lower limit <br> avg. EN 50160",
"EN50160.MINUTE":"min.",
"EN50160.PHASE":"Phase",
"EN50160.SECOND":"sec.",
"EN50160.THDUL1":"THD-U L1",
"EN50160.THDUL2":"THD-U L2",
"EN50160.THDUL3":"THD-U L3",
"EN50160.graphlabelout":"outside EN 50160",
"EN50160.harmtitle":"Individual harmonic components",
"EN50160.nominal":"NOMINAL VOLTAGE",
"EN50160.status":"values outside EN 50160",
"EN50160.statustitle":"EN 50160 status",
"EN50160.title":"EN 50160 Snapshot with Thresholds",
"IEC61000.GRAPHNORM":"Limit IEC 61000-2-4",
"IEC61000.MAXNORM":"Upper limit <br> avg. IEC 61000-2-4",
"IEC61000.MINNORM":"Lower limit <br> avg. IEC 61000-2-4",
"IEC61000.graphlabelout":"outside IEC 61000-2-4",
"IEC61000.nominal":"NOMINAL VOLTAGE",
"IEC61000.status":"values outside IEC 61000-2-4",
"IEC61000.statustitle":"IEC 61000-2-4 status",
"IEC61000.title":"IEC 61000-2-4 Snapshot (class 2) with Thresholds",
"IinA":"I in A",
"L1":"L1",
"L2":"L2",
"L3":"L3",
"L4":"L4",
"L4noAUX":"L4",
"RCM.ABSOLUTE":"Absolute value",
"RCM.ACTUAL":"Actual value",
"RCM.AVG":"Average value",
"RCM.AVGMAX":"Average. Maximum value",
"RCM.IL1":"Current L1",
"RCM.IL2":"Current L2",
"RCM.IL3":"Current L3",
"RCM.IN":"Current N (L4)",
"RCM.ISUM":"Current L1..L3",
"RCM.ISUMA":"Arithmetic current sum",
"RCM.KAN1":"RCM Channel 1 (L5)",
"RCM.KAN2":"RCM Channel 2 (L6)",
"RCM.LIMIT":"Limit Absolute",
"RCM.MAX":"Maximum value",
"RCM.PERCACTUAL":"% share RCM current from the Arithm. current sum",
"RCM.PERCENTAGE":"Percentage value",
"RCM.PERCLIMIT":"% share RCM limit from the Arithm. current sum",
"RCM.STATUS":"Status",
"RCM.of":"of",
"RCM.title":"RCM Snapshot with Thresholds",
"SumL1-L3":"L1..L3",
"SumL1-L4":"L1..L4",
"THD-I":"THD-I",
"THD-U":"THD-U",

////////////////////////
// Measurement values UMG604
////////////////////////

//voltage values
"_ULL[0]"   :   "Voltage L1-L2",
"_ULL[1]"   :   "Voltage L2-L3",
"_ULL[2]"   :   "Voltage L3-L1",
"_ULN[0]"   :   "Voltage L1-N",
"_ULN[1]"   :   "Voltage L2-N",
"_ULN[2]"   :   "Voltage L3-N",
"_ULN[3]"   :   "Voltage L4-N",
"_U_SYM"    :   "Imbalans voltage",


"_COS_PHI[0]":"Cos-phi L1",
"_COS_PHI[1]":"Cos-phi L2",
"_COS_PHI[2]":"Cos-phi L3",
"_COS_PHI[3]":"Cos-phi L4",
"_COS_SUM":"Cos-phi L1..L4",
"_COS_SUM3":"Cos-phi L1..L3",

"_FFT_IL1":"Harmonic Current L1",
"_FFT_IL2":"Harmonic Current L2",
"_FFT_IL3":"Harmonic Current L3",
"_FFT_IL4":"Harmonic Current L4",

"_FFT_ILZ1":"Inter Harmonic Currentm L1",
"_FFT_ILZ2":"Inter Harmonic Current L2",
"_FFT_ILZ3":"Inter Harmonic Current L3",
"_FFT_ILZ4":"Inter Harmonic Current L4",

"_FFT_PL1":"Harmonic Active Power L1",
"_FFT_PL2":"Harmonic Active Power L2",
"_FFT_PL3":"Harmonic Active Power L3",
"_FFT_PL4":"Harmonic Active Power L4",

"_FFT_QL1":"Harmonic Reactive Power L1",
"_FFT_QL2":"Harmonic Reactive Power L2",
"_FFT_QL3":"Harmonic Reactive Power L3",
"_FFT_QL4":"Harmonic Reactive Power L4",

"_FFT_UL1":"Harmonic Voltage L1",
"_FFT_UL1[0]":"1e harm. voltage L1",
"_FFT_UL1[10]":"11e harm. voltage L1",
"_FFT_UL1[11]":"12e harm. voltage L1",
"_FFT_UL1[12]":"13e harm. voltage L1",
"_FFT_UL1[13]":"14e harm. voltage L1",
"_FFT_UL1[14]":"15e harm. voltage L1",
"_FFT_UL1[15]":"16e harm. voltage L1",
"_FFT_UL1[16]":"17e harm. voltage L1",
"_FFT_UL1[17]":"18e harm. voltage L1",
"_FFT_UL1[18]":"19e harm. voltage L1",
"_FFT_UL1[19]":"20e harm. voltage L1",
"_FFT_UL1[1]":"2e harm. voltage L1",
"_FFT_UL1[20]":"21e harm. voltage L1",
"_FFT_UL1[21]":"22e harm. voltage L1",
"_FFT_UL1[22]":"23e harm. voltage L1",
"_FFT_UL1[23]":"24e harm. voltage L1",
"_FFT_UL1[24]":"25e harm. voltage L1",
"_FFT_UL1[2]":"3e harm. voltage L1",
"_FFT_UL1[3]":"4e harm. voltage L1",
"_FFT_UL1[4]":"5e harm. voltage L1",
"_FFT_UL1[5]":"6e harm. voltage L1",
"_FFT_UL1[6]":"7e harm. voltage L1",
"_FFT_UL1[7]":"8e harm. voltage L1",
"_FFT_UL1[8]":"9e harm. voltage L1",
"_FFT_UL1[9]":"10e harm. voltage L1",
"_FFT_UL2":"Harmonic Voltage L2",
"_FFT_UL2[0]":"1e harm. voltage L2",
"_FFT_UL2[10]":"11e harm. voltage L2",
"_FFT_UL2[11]":"12e harm. voltage L2",
"_FFT_UL2[12]":"13e harm. voltage L2",
"_FFT_UL2[13]":"14e harm. voltage L2",
"_FFT_UL2[14]":"15e harm. voltage L2",
"_FFT_UL2[15]":"16e harm. voltage L2",
"_FFT_UL2[16]":"17e harm. voltage L2",
"_FFT_UL2[17]":"18e harm. voltage L2",
"_FFT_UL2[18]":"19e harm. voltage L2",
"_FFT_UL2[19]":"20e harm. voltage L2",
"_FFT_UL2[1]":"2e harm. voltage L2",
"_FFT_UL2[20]":"21e harm. voltage L2",
"_FFT_UL2[21]":"22e harm. voltage L2",
"_FFT_UL2[22]":"23e harm. voltage L2",
"_FFT_UL2[23]":"24e harm. voltage L2",
"_FFT_UL2[24]":"25e harm. voltage L2",
"_FFT_UL2[2]":"3e harm. voltage L2",
"_FFT_UL2[3]":"4e harm. voltage L2",
"_FFT_UL2[4]":"5e harm. voltage L2",
"_FFT_UL2[5]":"6e harm. voltage L2",
"_FFT_UL2[6]":"7e harm. voltage L2",
"_FFT_UL2[7]":"8e harm. voltage L2",
"_FFT_UL2[8]":"9e harm. voltage L2",
"_FFT_UL2[9]":"10e harm. voltage L2",
"_FFT_UL3":"Harmonic Voltage L3",
"_FFT_UL3[0]":"1e harm. voltage L3",
"_FFT_UL3[10]":"11e harm. voltage L3",
"_FFT_UL3[11]":"12e harm. voltage L3",
"_FFT_UL3[12]":"13e harm. voltage L3",
"_FFT_UL3[13]":"14e harm. voltage L3",
"_FFT_UL3[14]":"15e harm. voltage L3",
"_FFT_UL3[15]":"16e harm. voltage L3",
"_FFT_UL3[16]":"17e harm. voltage L3",
"_FFT_UL3[17]":"18e harm. voltage L3",
"_FFT_UL3[18]":"19e harm. voltage L3",
"_FFT_UL3[19]":"20e harm. voltage L3",
"_FFT_UL3[1]":"2e harm. voltage L3",
"_FFT_UL3[20]":"21e harm. voltage L3",
"_FFT_UL3[21]":"22e harm. voltage L3",
"_FFT_UL3[22]":"23e harm. voltage L3",
"_FFT_UL3[23]":"24e harm. voltage L3",
"_FFT_UL3[24]":"25e harm. voltage L3",
"_FFT_UL3[2]":"3e harm. voltage L3",
"_FFT_UL3[3]":"4e harm. voltage L3",
"_FFT_UL3[4]":"5e harm. voltage L3",
"_FFT_UL3[5]":"6e harm. voltage L3",
"_FFT_UL3[6]":"7e harm. voltage L3",
"_FFT_UL3[7]":"8e harm. voltage L3",
"_FFT_UL3[8]":"9e harm. voltage L3",
"_FFT_UL3[9]":"10e harm. voltage L3",
"_FFT_UL4":"Harmonic Voltage L4",
"_FFT_UL4[0]":"1e harm. voltage L4",
"_FFT_UL4[10]":"11e harm. voltage L4",
"_FFT_UL4[11]":"12e harm. voltage L4",
"_FFT_UL4[12]":"13e harm. voltage L4",
"_FFT_UL4[13]":"14e harm. voltage L4",
"_FFT_UL4[14]":"15e harm. voltage L4",
"_FFT_UL4[15]":"16e harm. voltage L4",
"_FFT_UL4[16]":"17e harm. voltage L4",
"_FFT_UL4[17]":"18e harm. voltage L4",
"_FFT_UL4[18]":"19e harm. voltage L4",
"_FFT_UL4[19]":"20e harm. voltage L4",
"_FFT_UL4[1]":"2e harm. voltage L4",
"_FFT_UL4[20]":"21e harm. voltage L4",
"_FFT_UL4[21]":"22e harm. voltage L4",
"_FFT_UL4[22]":"23e harm. voltage L4",
"_FFT_UL4[23]":"24e harm. voltage L4",
"_FFT_UL4[24]":"25e harm. voltage L4",
"_FFT_UL4[2]":"3e harm. voltage L4",
"_FFT_UL4[3]":"4e harm. voltage L4",
"_FFT_UL4[4]":"5e harm. voltage L4",
"_FFT_UL4[5]":"6e harm. voltage L4",
"_FFT_UL4[6]":"7e harm. voltage L4",
"_FFT_UL4[7]":"8e harm. voltage L4",
"_FFT_UL4[8]":"9e harm. voltage L4",
"_FFT_UL4[9]":"10e harm. voltage L4",
"_FFT_ULL1":"Harmonic Voltage L1-L2",
"_FFT_ULL1[0]":"1e harm. voltage L1-L2",
"_FFT_ULL1[10]":"11e harm. voltage L1-L2",
"_FFT_ULL1[11]":"12e harm. voltage L1-L2",
"_FFT_ULL1[12]":"13e harm. voltage L1-L2",
"_FFT_ULL1[13]":"14e harm. voltage L1-L2",
"_FFT_ULL1[14]":"15e harm. voltage L1-L2",
"_FFT_ULL1[15]":"16e harm. voltage L1-L2",
"_FFT_ULL1[16]":"17e harm. voltage L1-L2",
"_FFT_ULL1[17]":"18e harm. voltage L1-L2",
"_FFT_ULL1[18]":"19e harm. voltage L1-L2",
"_FFT_ULL1[19]":"20e harm. voltage L1-L2",
"_FFT_ULL1[1]":"2e harm. voltage L1-L2",
"_FFT_ULL1[20]":"21e harm. voltage L1-L2",
"_FFT_ULL1[21]":"22e harm. voltage L1-L2",
"_FFT_ULL1[22]":"23e harm. voltage L1-L2",
"_FFT_ULL1[23]":"24e harm. voltage L1-L2",
"_FFT_ULL1[24]":"25e harm. voltage L1-L2",
"_FFT_ULL1[2]":"3e harm. voltage L1-L2",
"_FFT_ULL1[3]":"4e harm. voltage L1-L2",
"_FFT_ULL1[4]":"5e harm. voltage L1-L2",
"_FFT_ULL1[5]":"6e harm. voltage L1-L2",
"_FFT_ULL1[6]":"7e harm. voltage L1-L2",
"_FFT_ULL1[7]":"8e harm. voltage L1-L2",
"_FFT_ULL1[8]":"9e harm. voltage L1-L2",
"_FFT_ULL1[9]":"10e harm. voltage L1-L2",
"_FFT_ULL2":"Harmonic Voltage L2-L3",
"_FFT_ULL2[0]":"1e harm. voltage L2-L3",
"_FFT_ULL2[10]":"11e harm. voltage L2-L3",
"_FFT_ULL2[11]":"12e harm. voltage L2-L3",
"_FFT_ULL2[12]":"13e harm. voltage L2-L3",
"_FFT_ULL2[13]":"14e harm. voltage L2-L3",
"_FFT_ULL2[14]":"15e harm. voltage L2-L3",
"_FFT_ULL2[15]":"16e harm. voltage L2-L3",
"_FFT_ULL2[16]":"17e harm. voltage L2-L3",
"_FFT_ULL2[17]":"18e harm. voltage L2-L3",
"_FFT_ULL2[18]":"19e harm. voltage L2-L3",
"_FFT_ULL2[19]":"20e harm. voltage L2-L3",
"_FFT_ULL2[1]":"2e harm. voltage L2-L3",
"_FFT_ULL2[20]":"21e harm. voltage L2-L3",
"_FFT_ULL2[21]":"22e harm. voltage L2-L3",
"_FFT_ULL2[22]":"23e harm. voltage L2-L3",
"_FFT_ULL2[23]":"24e harm. voltage L2-L3",
"_FFT_ULL2[24]":"25e harm. voltage L2-L3",
"_FFT_ULL2[2]":"3e harm. voltage L2-L3",
"_FFT_ULL2[3]":"4e harm. voltage L2-L3",
"_FFT_ULL2[4]":"5e harm. voltage L2-L3",
"_FFT_ULL2[5]":"6e harm. voltage L2-L3",
"_FFT_ULL2[6]":"7e harm. voltage L2-L3",
"_FFT_ULL2[7]":"8e harm. voltage L2-L3",
"_FFT_ULL2[8]":"9e harm. voltage L2-L3",
"_FFT_ULL2[9]":"10e harm. voltage L2-L3",
"_FFT_ULL3":"Harmonic Voltage L3-L1",
"_FFT_ULL3[0]":"1e harm. voltage L3-L1",
"_FFT_ULL3[10]":"11e harm. voltage L3-L1",
"_FFT_ULL3[11]":"12e harm. voltage L3-L1",
"_FFT_ULL3[12]":"13e harm. voltage L3-L1",
"_FFT_ULL3[13]":"14e harm. voltage L3-L1",
"_FFT_ULL3[14]":"15e harm. voltage L3-L1",
"_FFT_ULL3[15]":"16e harm. voltage L3-L1",
"_FFT_ULL3[16]":"17e harm. voltage L3-L1",
"_FFT_ULL3[17]":"18e harm. voltage L3-L1",
"_FFT_ULL3[18]":"19e harm. voltage L3-L1",
"_FFT_ULL3[19]":"20e harm. voltage L3-L1",
"_FFT_ULL3[1]":"2e harm. voltage L3-L1",
"_FFT_ULL3[20]":"21e harm. voltage L3-L1",
"_FFT_ULL3[21]":"22e harm. voltage L3-L1",
"_FFT_ULL3[22]":"23e harm. voltage L3-L1",
"_FFT_ULL3[23]":"24e harm. voltage L3-L1",
"_FFT_ULL3[24]":"25e harm. voltage L3-L1",
"_FFT_ULL3[2]":"3e harm. voltage L3-L1",
"_FFT_ULL3[3]":"4e harm. voltage L3-L1",
"_FFT_ULL3[4]":"5e harm. voltage L3-L1",
"_FFT_ULL3[5]":"6e harm. voltage L3-L1",
"_FFT_ULL3[6]":"7e harm. voltage L3-L1",
"_FFT_ULL3[7]":"8e harm. voltage L3-L1",
"_FFT_ULL3[8]":"9e harm. voltage L3-L1",
"_FFT_ULL3[9]":"10e harm. voltage L3-L1",
"_FFT_ULZ1":"Inter Harmonic Voltage L1-L2",
"_FFT_ULZ2":"Inter Harmonic Voltage L2-L3",
"_FFT_ULZ3":"Inter Harmonic Voltage L3-L1",
"_FLI_LONG_TERM[0]":"Long term flicker L1",
"_FLI_LONG_TERM[1]":"Long term flicker L2",
"_FLI_LONG_TERM[2]":"Long term flicker L3",
"_FLI_LONG_TERM[3]":"Long term flicker L4",
"_FLI_SHORT_TERM[0]":"Short term flicker L1",
"_FLI_SHORT_TERM[1]":"Short term flicker L2",
"_FLI_SHORT_TERM[2]":"Short term flicker L3",
"_FLI_SHORT_TERM[3]":"Short term flicker L4",
"_FREQ":"Frequency",
"_ILN[0]":"Current L1",
"_ILN[1]":"Current L2",
"_ILN[2]":"Current L3",
"_ILN[3]":"Current L4",
"_IQH[0]":"Reactive energy ind. L1",
"_IQH[1]":"Reactive energy ind. L2",
"_IQH[2]":"Reactive energy ind. L3",
"_IQH[3]":"Reactive energy ind. L4",
"_IQH[4]":"Reactive energy ind. L1..L3",
"_IQH[5]":"Reactive energy ind. L1..L4",
"_I_SUM":"Current L1..L4",
"_I_SUM3":"Current L1..L3",
"_PLN[0]":"Active power L1",
"_PLN[1]":"Active power L2",
"_PLN[2]":"Active power L3",
"_PLN[3]":"Active power L4",
"_P_SUM":"Active power L1..L4",
"_P_SUM3":"Active power L1..L3",
"_QH[0]":"Reactive energy L1",
"_QH[1]":"Reactive energy L2",
"_QH[2]":"Reactive energy L3",
"_QH[3]":"Reactive energy L4",
"_QH[4]":"Reactive energy L1..L3",
"_QH[5]":"Reactive energy L1..L4",
"_QLN[0]":"Reactive power L1",
"_QLN[1]":"Reactive power L2",
"_QLN[2]":"Reactive power L3",
"_QLN[3]":"Reactive power L4",
"_Q_SUM":"Reactive power L1..L4",
"_Q_SUM3":"Reactive power L1..L3",
"_SLN[0]":"Apparent power L1",
"_SLN[1]":"Apparent power L2",
"_SLN[2]":"Apparent power L3",
"_SLN[3]":"Apparent power L4",
"_S_SUM":"Apparent power L1..L4",
"_S_SUM3":"Apparent power L1..L3",
"_THD_IL[0]":"THD-I L1",
"_THD_IL[1]":"THD-I L2",
"_THD_IL[2]":"THD-I L3",
"_THD_IL[3]":"THD-I L4",
"_THD_ULL[0]":"THD-U L1-L2",
"_THD_ULL[1]":"THD-U L2-L3",
"_THD_ULL[2]":"THD-U L3-L1",
"_THD_ULN[0]":"THD-U L1-N",
"_THD_ULN[1]":"THD-U L2-N",
"_THD_ULN[2]":"THD-U L3-N",
"_THD_ULN[3]":"THD-U L4-N",

"_WH[0]":"Real energy L1",
"_WH[1]":"Real energy L2",
"_WH[2]":"Real energy L3",
"_WH[3]":"Real energy L4",
"_WH[4]":"Real energy L1..L3",
"_WH[5]":"Real energy L1..L4",
"_WH_S[0]":"Apparent energy L1",
"_WH_S[1]":"Apparent energy L2",
"_WH_S[2]":"Apparent energy L3",
"_WH_S[3]":"Apparent energy L4",
"_WH_S[4]":"Apparent energy L1..L3",
"_WH_S[5]":"Apparent energy L1..L4",
"_WH_V[0]":"Real energy consumed L1",
"_WH_V[1]":"Real energy consumed L2",
"_WH_V[2]":"Real energy consumed L3",
"_WH_V[3]":"Real energy consumed L4",
"_WH_V[4]":"Real energy consumed L1..L3",
"_WH_V[5]":"Real energy consumed L1..L4",
"_WH_Z[0]":"Real energy delivered L1",
"_WH_Z[1]":"Real energy delivered L2",
"_WH_Z[2]":"Real energy delivered L3",
"_WH_Z[3]":"Real energy delivered L4",
"_WH_Z[4]":"Real energy delivered L1..L3",
"_WH_Z[5]":"Real energy delivered L1..L4",
"about.title":"About",
"activepower":"Active power",
"app1.text":"Use the measurement monitor APP for the presentation of real-time and historical data recorded by your Janitza analyzer in easy-to-read webbased graphs. No external server or software is needed.<br><br>- Optimized for use with PC Laptop and tablet<br>- Selection of measurement variables with drag-and-drop function<br>- Select your timeframe with the embedded calendar function<br>- Automatic recognition of stored measuring variables in the Janitza analyzer<br>- Possibility to change graph colours",
"app1.title":"Measurement monitor",
"app2.text":"With the Mini EnMs APP you're creating a small local webbased Energy Management system on your Janitza Analyser. You can use Janitza energy meters without memory because the most common variables are stored in the 'head-meter'. <br><br>- Optimized for use with PC laptop and tablet<br>- Selection of measurement variables of the master and the slaves with drag-and-drop function<br>- Select you timeframe with the embedded calendar function<br>- Main variables of the modbus slaves are stored and presented via the 'head-meter'<br>- Not necessary to use extra software or servers. A standard browser is enough",
"app2.title":"Mini EnMs",
"app3.text":"The requirements concerning the voltage quality at the supplier's side should apply the EN 50160 which characterizes voltage parameters of electrical energy in public distribution systems.  The EN 50160 concerns the supply voltage i.e. that measured at the point of common coupling. With the power quality watchdog in accordance with EN 50160 all the algorithms (incl. the 95% and 100% values) are integrated in the meter itself.<br><br>- Embedded watchdog functionality<br>- Not neccesary to transfer high amounts of measuring data  from the meter to a host system<br>- Saving communication costs in remote applications<br>- Easy Analysis with embedded traffic light principle<br>- Possible to do PQ-analyses without specific power quality knowledge",
"app3.title":"Power Quality Watchdog EN50160",
"app4.text":"The IEC61000-2-4  gives numerical compatibility levels for industrial and non-public power distribution systems at nominal voltages up to 35 kV. It's  a must to monitor continuously the voltage quality in every critical installation  in accordance with the IEC61000-2-4 to guarantee a proper work of the equipment installed.<br><br>- Embedded watchdog functionality in accordance with the IEC61000-2-4 standard<br>- Not necessary to transfer high amounts of measuring data from the meter to a host system<br>- Saving communication costs in remote applications<br>- Easy Analysis with embedded traffic light principle<br>- Possible to do PQ-analyses without specific power quality knowledge",
"app4.title":"Power Quality Watchdog IEC61000-2-4",
"apparentpower":"Apparent power",
"apps.title":"Apps",
"apps.titletext":"The term 'Apps' is the short form of Applications and are supplemental programs that provide extra functionality. These Apps are easy and quick to install and cover a wide spectrum of views and specific measurement tasks to complex analysis tools.",
"button.open":"Open",
"company.director":"Managing director",
"company.tax":"Tax number",
"company.traderegister":"Trade register",
"company.vat":"Vat No.",
"confdisplay.activeFALSE":"Inactive",
"confdisplay.activeTRUE":"Active",
"config.data_transfer":"transferring data...",
"config.submit":"Submit Configuration",
"config.title":"Main Configuration",
"cos-phi":"cos-phi",
"cosphi":"Cos-phi",
"current":"Current",
"display.text1":"On this page you can see an image of the device display.<br>This image matches the device display at all times",
"display.text2":"By pressing the 6 buttons with your mouse you are able to telecontrol the device.",
"display.texttitle":"Live device overview",
"events.bound":"Limit",
"events.duration":"Duration",
"events.eventtitle":"Event",
"events.item":"Event",
"events.list":"List of events",
"events.overcurrent":"Over Current",
"events.overvoltage":"Over Voltage",
"events.reason":"Reason",
"events.records":"Values",
"events.undervoltage":"Under Voltage",
"events.voltageoff":"Power failure",
"freq":"Frequency",
"harm.bcurrent":"Inter Harmonic Current",
"harm.bvoltageull":"Inter Harmonic Voltage (LL)",
"harm.current":"Harmonic Current",
"harm.effective_power":"Harmonic Active Power",
"harm.reactive_power":"Harmonic Reactive Power",
"harm.voltage":"Harmonic Voltage",
"harm.voltageull":"Harmonic Voltage (LL)",
"harm.voltageuln":"Harmonic Voltage (LN)",
"help.d1-1":"No display",
"help.d1-2-1":"External fusing for the power supply voltage has tripped.",
"help.d1-3-1":"Replace fuse.",
"help.d10-1":"EEE bAt in the display",
"help.d10-2-1":"Battery capacity is too low",
"help.d10-3-1":"See 'Battery control function' and 'Replacing the battery' (Manual)",
"help.d11-1":"Device still does not work despite the above measures.",
"help.d11-2-1":"Device defective.",
"help.d11-3-1":"Send the device to the manufacturer for inspection and testing along with an accurate fault description.",
"help.d2-1":"No current display",
"help.d2-2-1":"Measurement voltage is not connected.",
"help.d2-2-2":"Measurement current is not connected.",
"help.d2-3-1":"Connect the measuring-circuit voltage.",
"help.d2-3-2":"Connect measuring-circuit current.",
"help.d3-1":"Current displayed is too large or too small.",
"help.d3-2-1":"Current measurement in the wrong phase.",
"help.d3-2-2":"Current transformer factor is incorrectly programmed.",
"help.d3-2-3":"The current peak value at the measurement input was exceeded by harmonic components.",
"help.d3-2-4":"The current at the measurement input fell short of.",
"help.d3-3-1":"Check connection and correct if necessary.",
"help.d3-3-2":"Read out and program the current transformer transformation ratio at the current transformer.",
"help.d3-3-3":"Install current transformer with a larger transformation ratio.",
"help.d3-3-4":"Install current transformer with a suitable transformation ratio.",
"help.d4-1":"Voltage displayed is too large or too small.",
"help.d4-2-1":"Measurement in the wrong phase.",
"help.d4-2-2":"Voltage transformer incorrectly programmed.",
"help.d4-3-1":"Check connection and correct if necessary.",
"help.d4-3-2":"Read out and program the voltage transformer transformation ratio at the voltage transformer.",
"help.d5-1":"Voltage displayed is too small.",
"help.d5-2-1":"Overrange.",
"help.d5-2-2":"The peak voltage value at the measurement input has been exceeded by harmonic components.",
"help.d5-3-1":"Install voltage transformers.",
"help.d5-3-2":"Caution! Ensure the measurement inputs are not overloaded.",
"help.d6-1":"Phase shift ind/cap.",
"help.d6-2-1":"A current path is assigned to the wrong voltage path.",
"help.d6-3-1":"Check connection and correct if necessary.",
"help.d7-1":"Effective power consumption/supply reversed.",
"help.d7-2-1":"At least one current transformer connection is mixed up/reversed.",
"help.d7-2-2":"A current path is assigned to the wrong voltage path.",
"help.d7-3-1":"Check connection and correct if necessary.",
"help.d7-3-2":"Check connection and correct if necessary.",
"help.d8-1":"Effective power too large or too small.",
"help.d8-2-1":"The programmed current transformer transformation ratio is incorrect.",
"help.d8-2-2":"The current path is assigned to the wrong voltage path.",
"help.d8-2-3":"The programmed voltage transformer transformation ratio is incorrect.",
"help.d8-3-1":"Read out and program the current transformer transformation ratio at the current transformer",
"help.d8-3-2":"Check connection and correct if necessary.",
"help.d8-3-3":"Read out and program the voltage transformer transformation ratio at the voltage transformer.",
"help.d9-1":"An output is not responding.",
"help.d9-2-1":"The output was incorrectly programmed.",
"help.d9-2-2":"The output was incorrectly connected.",
"help.d9-3-1":"Check the settings and correct if necessary.",
"help.d9-3-2":"Check connection and correct if necessary.",
"help.h1":"Possible fault",
"help.h2":"Cause",
"help.h3":"Remedy",
"help.title":"Help",
"home.activepower":"Active Power",
"home.apparentpower":"Apparent Power",
"home.cos-phi":"Cos-Phi",
"home.last31daygraphtitle":"Energy consumption current and last month (kWh)",
"home.lastmonth":"Last Month",
"home.reactivepower":"Reactive Power",
"home.thismonth":"This Month",
"home.today":"Today",
"home.todaygraphtitle":"Load profile today and yesterday(kWh)",
"home.usage-currentmonth":"CURRENT MONTH",
"home.usage-lastmonth":"LAST MONTH",
"home.usage-today":"TODAY",
"home.usage-yesterday":"YESTERDAY",
"home.yesterday":"Yesterday",
"info.485":"RS485",
"info.485adr":"Address",
"info.485baud":"Baudrate",
"info.485master":"Modbus-Master(Gateway)",
"info.485mode":"Mode",
"info.485profi":"Profibus",
"info.485slave":"Modbus-Slave",
"info.Input":"Dig. Input",
"info.Output":"Dig. Output",
"info.State":"State",
"info.VoltageOver":"Over Voltage",
"info.VoltageUnder":"Under Voltage",
"info.apparentpower":"Apparent Power",
"info.avg":"Average value",
"info.avgmax":"Avg. max. value",
"info.comm":"Communication",
"info.content_desc":"Actual value",
"info.cosphi":"cos(phi)",
"info.crestfactor":"crest factor",
"info.ct":"Current transformer ratio and nominal values",
"info.ct_RM":"Current transformer ratio",
"info.data_count":"Data count",
"info.dev_desc":"Device description",
"info.dev_name":"Device name",
"info.devicetime":"Device time",
"info.dns_addr":"DNS Server",
"info.drehfeldkomponenten":"Rotating Field Components",
"info.effectiveenergy":"Real energy",
"info.effectiveenergycon":"Real energy consumed",
"info.effectiveenergydel":"Real energy delivered",
"info.effectivepower":"Active Power",
"info.firmware.release":"Firmware Release",
"info.fix_ip":"Fixed IP",
"info.frequency":"Frequency",
"info.gegensystem":"Negative phase sequence",
"info.general":"General information",
"info.gw":"Gateway",
"info.harmonic_distortion":"Total Harmonic Distortion",
"info.hpversion":"HP version",
"info.induktiv":"Inductive",
"info.infomessage":"*Depends on configuration",
"info.ip":"Ethernet",
"info.ip_addr":"IP address",
"info.ip_mask":"Subnet-Mask",
"info.libversion":"Lib version",
"info.max":"Maximum value",
"info.min":"Minimum value",
"info.mitsystem":"Positive phase sequence",
"info.nomcurrent":"Nominal current",
"info.nomvoltage":"Nominal voltage",
"info.nullsystem":"Zero phase sequence",
"info.off":"0",
"info.on":"1",
"info.peak.crest":"Peakvalues Crestfactor",
"info.percental":"percentage",
"info.porthelptxt":"Using the check boxes you can directly switch the state of the digital output.",
"info.reactiveenergy":"Reactive energy",
"info.reactiveenergycap":"Reactive energy capacitive",
"info.reactiveenergyind":"Reactive energy inductive",
"info.reactivepower":"Reactive Power",
"info.serialnumber":"Serial number",
"info.starttime":"Starttime",
"info.temperature":"Temperature",
"info.time.today":"Today",
"info.time.yesterday":"Yesterday",
"info.title":"Information",
"info.total_interharmonic_distortion":"Total Interharmonic Distortion",
"info.var_desc":"Description",
"info.vt":"Voltage transformer ratio and nominal values",
"info.vt_RM":"Voltage transformer ratio",
"infow.counter":"S0 Counter",
"infow.hightariff":"High Tariff",
"infow.lowtariff":"Low Tariff",
"infow.power":"S0 Power",
"infow.sum":"Sum",
"kW":"kW",
"kWh":"kWh",
"kvar":"kvar",
"kvarh":"kvarh",
"menu.EN50160":"EN 50160",
"menu.IEC61000":"IEC 61000-2-4",
"menu.RCM":"RCM",
"menu.about":"About",
"menu.apps":"Apps",
"menu.appsoverview":"Apps Overview",
"menu.changelog":"Changelog",
"menu.current":"Current",
"menu.deviceinfo":"Device information",
"menu.display":"Display",
"menu.downloads":"Downloads",
"menu.energy":"Energy",
"menu.events":"Events",
"menu.events.rec":"Events",
"menu.fft":"Harmonics",
"menu.flicker":"Flicker",
"menu.help":"Help",
"menu.home":"Home",
"menu.impressum":"Imprint",
"menu.info":"Information",
"menu.overview":"Overview",
"menu.periphery":"Periphery",
"menu.power":"Power",
"menu.soverview":"Quickview",
"menu.transient":"Transients",
"menu.transient.rec":"Transients",
"menu.values":"Measurement values",
"menu.voltage":"Voltage",
"overview.device":"DEVICE",
"overview.devicedescription":"Description",
"overview.time":"Time / Date",
"peak.neg":"neg. peak",
"peak.peak":"Peak-Peak",
"peak.pos":"pos. peak",
"reactivepower":"Reactive power",
"soverview.device":"DEVICE",
"soverview.freq":"Frequency (LN)",
"soverview.phase":"Phase",
"soverview.time":"Time / Date",
"soverview.uvll":"U in V <br> (LL)",
"soverview.uvln":"U in V <br> (LN)",
"sternpunktspannung":"neutral point voltage",
"thd":"THD",
"trans.list":"List of transients",
"trans.transient":"Transient",
"trans.transtitle":"Transient",
"unsymmetrie.spannung":"unsymmetric voltage",
"unsymmetrie.strom":"Unsymmetric current",
"values.flickerlt":"Long term flicker",
"values.flickerpf5":"Actual Flicker",
"values.flickerst":"Short term flicker",
"values.harmonic_i":"Harmonic Current",
"values.harmonic_u":"Harmonic Voltage ULN",
"values.harmonic_ull":"Harmonic Voltage ULL",
"values.interharmonic_i":"Interharmonic Current",
"values.interharmonic_ull":"Interharmonic Voltage ULL",
"voltage":"Voltage",
"voltage.between.lines":"Voltage Between Lines",
'dummy':'dummy'
}
);
TimeStrArray = new Array(TimeStrArray,mapIdsToArray("month.",12),
mapIdsToArray("weekday.",6)
);